%global qt_module qtwayland
%global __provides_exclude_from ^%{_qt5_archdatadir}/qml/.*\\.so$

Summary: Qt5 - Wayland platform support and QtCompositor module
Name:    qt5-%{qt_module}
Version: 5.15.11
Release: 1%{?dist}
License: LGPLv3
Url:     http://www.qt.io
%global majmin %(echo %{version} | cut -d. -f1-2)
Source0: https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-opensource-src-%{version}.tar.xz

Patch0001:  0001-Client-Announce-an-output-after-receiving-more-compl.patch
Patch0002:  0002-Fix-issue-with-repeated-window-size-changes.patch
Patch0003:  0003-Client-Connect-drags-being-accepted-to-updating-the-.patch
Patch0004:  0004-Client-Disconnect-registry-listener-on-destruction.patch
Patch0005:  0005-Client-Set-XdgShell-size-hints-before-the-first-comm.patch
Patch0006:  0006-Fix-build.patch
Patch0007:  0007-Fix-remove-listener.patch
Patch0008:  0008-Hook-up-queryKeyboardModifers.patch
Patch0009:  0009-Correctly-detect-if-image-format-is-supported-by-QIm.patch
Patch0010:  0010-Client-Don-t-always-recreate-frame-callbacks.patch
Patch0011:  0011-Client-Always-destroy-frame-callback-in-the-actual-c.patch
Patch0012:  0012-Wayland-client-use-wl_keyboard-to-determine-active-s.patch
Patch0013:  0013-Client-do-not-empty-clipboard-when-a-new-popup-windo.patch
Patch0014:  0014-Client-Implement-DataDeviceV3.patch
Patch0015:  0015-Client-Delay-deletion-of-QDrag-object-until-after-we.patch
Patch0016:  0016-Client-Avoid-processing-of-events-when-showing-windo.patch
Patch0017:  0017-Handle-registry_global-out-of-constructor.patch
Patch0018:  0018-Connect-flushRequest-after-forceRoundTrip.patch
Patch0019:  0019-Move-the-wayland-socket-polling-to-a-separate-event-.patch
Patch0020:  0020-Client-Remove-mWaitingForUpdateDelivery.patch
Patch0021:  0021-client-Simplify-round-trip-behavior.patch
Patch0022:  0022-Client-Fix-opaque-region-setter.patch
Patch0023:  0023-Use-proper-dependencies-in-compile-tests.patch
Patch0024:  0024-Revert-Client-Remove-mWaitingForUpdateDelivery.patch
Patch0025:  0025-Fix-race-condition-on-mWaitingForUpdateDelivery.patch
Patch0026:  0026-use-poll-2-when-reading-from-clipboard.patch
Patch0027:  0027-Reduce-memory-leakage.patch
Patch0028:  0028-Only-close-popup-in-the-the-hierchary.patch
Patch0029:  0029-Check-pointer-for-null-before-use-in-ASSERT.patch
Patch0030:  0030-Use-wl_surface.damage_buffer-on-the-client-side.patch
Patch0031:  0031-Client-clear-focus-on-touch-cancel.patch
Patch0032:  0032-Guard-mResizeDirty-by-the-correctMutex.patch
Patch0033:  0033-Fix-compile-tests.patch
Patch0034:  0034-Call-finishDrag-in-QWaylandDataDevice-dragSourceCanc.patch
Patch0035:  0035-Hold-surface-read-lock-throughout-QWaylandEglWindow-.patch
Patch0036:  0036-Keep-toplevel-windows-in-the-top-left-corner-of-the-.patch
Patch0037:  0037-Client-Add-F_SEAL_SHRINK-seal-to-shm-backing-file.patch
Patch0038:  0038-Client-Call-wl_output_release-upon-QWaylandScreen-de.patch
Patch0039:  0039-Client-Bump-wl_output-version.patch
Patch0040:  0040-Fix-frame-sync-related-to-unprotected-multithread-ac.patch
Patch0041:  0041-Client-Handle-zwp_primary_selection_device_manager_v.patch
Patch0042:  0042-Fixes-the-build-on-CentOS.patch
Patch0043:  0043-client-Avoid-protocol-error-with-invalid-min-max-siz.patch
Patch0044:  0044-Client-Fix-handling-of-Qt-BlankCursor.patch
Patch0045:  0045-client-Force-a-roundtrip-when-an-XdgOutput-is-not-re.patch
Patch0046:  0046-Client-Manage-QMimeData-lifecycle.patch
Patch0047:  0047-client-Do-not-cast-placeholder-screens-to-QWaylandSc.patch
Patch0048:  0048-Client-Remove-flip-popup-constraints.patch
Patch0049:  0049-Destroy-frame-queue-before-display.patch
Patch0050:  0050-client-Fix-crash-on-dnd-updates-after-client-facing-.patch
Patch0051:  0051-Convert-cursor-bitmap-to-supported-format.patch
Patch0052:  0052-Replace-scale-with-devicePixelRatio-for-non-integer-.patch
Patch0053:  0053-Client-Fix-buffer-damage.patch
Patch0054:  0054-client-Fix-infinite-recursion-with-text-input-v2.patch
Patch0055:  0055-Client-Fix-the-mouse-being-stuck-in-pressed-state-af.patch
Patch0056:  0056-Client-Commit-the-initial-surface-state-explicitly.patch
Patch0057:  0057-tests-Fix-tst_xdgshell-minMaxSize.patch
Patch0058:  0058-Client-Remove-some-surface-commits.patch
Patch0059:  0059-Client-Avoid-locking-resizing-in-QWaylandShmBackingS.patch

Patch3000:    qtwayland-use-adwaita-decorations-by-default.patch
Patch3001:    qtwayland-decoration-support-backports-from-qt6.patch

BuildRequires: make
BuildRequires:  qt5-qtbase-devel >= %{version}, qt5-qtbase-static, qt5-qtbase-private-devel, qt5-qtdeclarative-devel
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}

BuildRequires:  pkgconfig(xkbcommon), pkgconfig(xcomposite), pkgconfig(xrender)
BuildRequires:  pkgconfig(wayland-scanner), pkgconfig(wayland-server), pkgconfig(wayland-client), pkgconfig(wayland-cursor), pkgconfig(wayland-egl)
BuildRequires:  pkgconfig(egl), pkgconfig(gl), pkgconfig(libudev), pkgconfig(libinput), libXext-devel

%description
%{summary}.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{version}-%{release}
Requires: qt5-qtbase-devel
%description devel
%{summary}.



%prep
%autosetup -n %{qt_module}-everywhere-src-%{version} -p1



%build
%{qmake_qt5}

%make_build



%install
make install INSTALL_ROOT=%{buildroot}

pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd



%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig



%files
%license LICENSE.*
%doc README
%{_qt5_libdir}/libQt5WaylandCompositor.so.5*
%{_qt5_libdir}/libQt5WaylandClient.so.5*
%{_qt5_plugindir}/wayland-decoration-client/
%{_qt5_plugindir}/wayland-graphics-integration-server
%{_qt5_plugindir}/wayland-graphics-integration-client
%{_qt5_plugindir}/wayland-shell-integration
%{_qt5_plugindir}/platforms/libqwayland-egl.so
%{_qt5_plugindir}/platforms/libqwayland-generic.so
%{_qt5_plugindir}/platforms/libqwayland-xcomposite-egl.so
%{_qt5_plugindir}/platforms/libqwayland-xcomposite-glx.so
%{_qt5_qmldir}/QtWayland/

%files devel
%{_qt5_bindir}/qtwaylandscanner
%{_qt5_headerdir}/QtWaylandCompositor/
%{_qt5_headerdir}/QtWaylandClient/
%{_qt5_libdir}/libQt5WaylandCompositor.so
%{_qt5_libdir}/libQt5WaylandClient.so
%{_qt5_libdir}/libQt5WaylandCompositor.prl
%{_qt5_libdir}/libQt5WaylandClient.prl
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/Qt5WaylandCompositorConfig*.cmake
%{_qt5_libdir}/pkgconfig/*.pc
%{_qt5_archdatadir}/mkspecs/modules/*.pri
%{_qt5_libdir}/cmake/Qt5WaylandCompositor/
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_*.cmake
%{_qt5_libdir}/cmake/Qt5WaylandClient/
%{_qt5_examplesdir}/wayland/


%changelog
* Wed Jan 10 2024 edwardewang <edwardewang@tencent.com> - 5.15.11-1
- Upgrade to 5.15.11

* Wed Sep 20 2023 kianli <kianli@tencent.com> - 5.15.10-1
- Upgrade to 5.15.10

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.9-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 17 2023 Shuo Wang <abushwang@tencent.com> - 5.15.9-1
- update to 5.15.9

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.7-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 8 2022 Zhao Zhen <jeremiazhao@tencent.com> - 5.15.7-1
- initial
